<?php

namespace FiloBlu\Refilo\Controller\Adminhtml\Exporter;

use Exception;
use FiloBlu\Refilo\Model\Indexer\Pages as IndexerPages;
use Magento\Framework\App\Action\HttpGetActionInterface as HttpGetActionInterface;
use Magento\Framework\Controller\ResultFactory;
use Magento\Framework\Message\ManagerInterface;

class Cmspages implements HttpGetActionInterface
{
    /**
     * @var
     */
    private $messageManager;
    /**
     * @var ResultFactory
     */
    private $resultFactory;
    /**
     * @var IndexerPages
     */
    protected $pagesIndexer;

    /**
     * Countries constructor.
     * @param ResultFactory $resultFactory
     * @param ManagerInterface $messageManager
     * @param IndexerPages $indexerPages
     */
    public function __construct(
        ResultFactory $resultFactory,
        ManagerInterface $messageManager,
        IndexerPages $indexerPages
    ) {
        $this->resultFactory = $resultFactory;
        $this->messageManager = $messageManager;
        $this->pagesIndexer = $indexerPages;
    }

    public function execute()
    {
        try {
            //@ToDo Reimplement it as query as soon as a solution for regions is found
            $this->pagesIndexer->executeFull();
            $this->messageManager->addSuccessMessage(__('CMS pages successfully synced with MongoDB'));
        } catch (Exception $e) {
            $this->messageManager->addExceptionMessage($e);
        }

        $resultRedirect = $this->resultFactory->create(ResultFactory::TYPE_REDIRECT);
        return $resultRedirect->setPath('indexer/indexer/list/');
    }
}
